| Disk ARchive 2.5.10 Full featured and portable backup and archiving tool

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
libdar::path Class Reference
API

the class path is here to manipulate paths in the Unix notation: using'/' More...

`#include <path.hpp>`

Inherits libdar::on_pool.

## Public Member Functions
| path (const std::string &s, bool x_undisclosed=false)
| constructor from a string More...
| path (const char *s, bool x_undisclosed=false)
| constructor from a char * More...
| path (const path &ref)
| copy constructor
const path & | operator= (const path &ref)
| assignment operator
bool | operator== (const path &ref) const
| comparison operator
bool | operator!= (const path &ref) const
std::string | basename () const
| get the basename of a path More...
void | reset_read ()
| reset the read_subdir operation More...
bool | read_subdir (std::string &r)
| sequentially read the elements that compose the path More...
bool | is_relative () const
| whether the path is relative or absolute (= start with a /)
bool | is_absolute () const
| whether the path is absolute or relative
bool | is_undisclosed () const
| whether the path has an undisclosed part at the beginning
bool | pop (std::string &arg)
| remove and gives in argument the basename of the path More...
bool | pop_front (std::string &arg)
| remove and gives in argument the outer most member of the path More...
path | operator+ (const path &arg) const
| add a path to the current path. The added path must be a relative path More...
path & | operator+= (const path &arg)
| add a path to the current path. The added path must be a relative path More...
bool | is_subdir_of (const path &p, bool case_sensit) const
| test whether the current object is a subdir of the method's argument More...
std::string | display () const
| convert back a path to a string More...
unsigned int | degre () const
| returns the number of member in the path More...
void | explode_undisclosed () const
| if the current object is an undisclosed path, tries to convert it back to normal path
Public Member Functions inherited from libdar::on_pool
void * | operator new (size_t n_byte)
void * | operator new (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new[] (size_t n_byte)
void * | operator new[] (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new (size_t n_byte, memory_pool *p)
void * | operator new[] (size_t n_byte, memory_pool *p)
void | operator delete (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated object
void | operator delete[] (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated objects
void | operator delete (void *ptr)
| this is the usual delete operator, modified to handle allocated objects allocated on a memory pool or not
void | operator delete[] (void *ptr)
| this is the usual delete[] operator, modified to handle allocated objects allocated on a memory pool or not

## Additional Inherited Members
Protected Member Functions inherited from libdar::on_pool
memory_pool * | get_pool () const
template<class T >
void | meta_new (T *&ptr, size_t num)
template<class T >
void | meta_delete (T *ptr)

## Detailed Description

the class path is here to manipulate paths in the Unix notation: using'/'

several operations are provided as well as convertion functions, but for the API user, it can be used as if it was a std::string object. However if the argument is not a valid path, an exception may be thrown by libdar

Definition at line 50 of file path.hpp.

## Constructor & Destructor Documentation

libdar::path::path | ( | const std::string & | s,
|  | bool | x_undisclosed = `false`
| ) |  |

constructor from a string

This realizes the string to path convertion function

Parameters

  [in] | s | the string to convert to path
  [in] | x_undisclosed | do not split the given string, consider it as a single directory name, even if some '/' are found in it

Note
  empty string is not a valid string (exception thrown)
  having undisclosed set to true, does not allow one to pop() right away, first push must be made. While having undisclosed set to false let the user pop() right away if the given string is composed of several path members ("member1/member2/member3" for example of path allow one to pop() three time, while in the same example setting undisclosed to true, allow one to pop() just once).

libdar::path::path | ( | const char * | s,
|  | bool | x_undisclosed = `false`
| ) |  |
| inline

constructor from a char *

this realizes the char * to path convertion function

Note
  empty string is not a valid string (exception thrown)

Definition at line 68 of file path.hpp.

References path().

Referenced by path().

## Member Function Documentation

std::string libdar::path::basename | ( |  | ) | const

get the basename of a path

this function returns the basename that's it the right most member of a path

unsigned int libdar::path::degre | ( |  | ) | const
| inline

returns the number of member in the path

Note
  a absolute path counts one more that its relative brother

Definition at line 152 of file path.hpp.

std::string libdar::path::display | ( |  | ) | const

convert back a path to a string

the returned string is the representation of the current object in Unix notation

Referenced by libdar::mask::is_covered(), and libdar::entrepot::set_root().

bool libdar::path::is_subdir_of | ( | const path & | p,
|  | bool | case_sensit
| ) |  | const

test whether the current object is a subdir of the method's argument

Parameters

  [in] | p | the path to test with
  [in] | case_sensit | whether the test must be in case sensitive manner or not

Referenced by libdar::exclude_dir_mask::is_covered().

path libdar::path::operator+ | ( | const path & | arg | ) | const
| inline

add a path to the current path. The added path must be a relative path

Parameters

  [in] | arg | the relative path to add

Returns
  the resulting path, (the current object is not modified, where from the "const" qualifier)

Note
  arg can be a string also, which is converted to a path on the fly

Definition at line 129 of file path.hpp.

path& libdar::path::operator+= | ( | const path & | arg | ) |

add a path to the current path. The added path must be a relative path

Parameters

  [in] | arg | the relative path to add

Returns
  the value of the current (modified) object: "*this".

bool libdar::path::pop | ( | std::string & | arg | ) |

remove and gives in argument the basename of the path

Parameters

  [out] | arg | the basename of the path

Returns
  false if the operation was not possible (no sub-directory to pop)

Note
  if the path is absolute the remaing value is '/' when no pop is anymore possible while it is the first component of the original path if the path was relative. a empty path is not a valide value

bool libdar::path::pop_front | ( | std::string & | arg | ) |

remove and gives in argument the outer most member of the path

Parameters

  [out] | arg | the value of the outer element of the path

Returns
  true if the pop_front operation was possible and arg could be set.

Note
  removes and returns the first directory of the path, when just the basename is present returns false, if the path is absolute, the first call change it to relative (except if equal to "/" then return false)

bool libdar::path::read_subdir | ( | std::string & | r | ) |

sequentially read the elements that compose the path

Parameters

  [out] | r | the next element of the path

Returns
  true if a next element could be read

Note
  the reading starts at the root and ends with the basename of the path

void libdar::path::reset_read | ( |  | ) |
| inline

reset the read_subdir operation

reset for read_subdir. next call to read_subdir is the most global

Definition at line 88 of file path.hpp.

The documentation for this class was generated from the following file:

- path.hpp